What is Files Comparer

Welcome to Files Comparer

Files Comparer is a visual tool for files and directories comparison. It helps you to compare and merge different versions of the same textual file. A color-coded side-by-side comparison makes it easy to understand differences between two files at a glance, powerful editing engine helps you to merge found changes and edit text directly. Files Comparer has a number of simple and convenient features that many users have been expecting for a long time from a comparison program.

The main features of Files Comparer are:

  • Displays files side-by-side

  • Colored differences sections to simplify analyzing

  • Move changes between files with single mouse click or keystroke

  • Easy navigation through the differences

  • Ability to edit files directly in comparison window

  • Allowing to ignore blanks, case, whitespace

  • Regular expressions support

  • Customizable fonts and colors

  • Adjustable pane splitter and synchronized scrolling

  • Editor with undo/redo, search and bookmarks

  • Include/exclude files and directories filters

  • Copying and deleting files directly

  • Drag and drop support for dropping one or two files or directories for comparison

and much more.


Requirements

Files Comparer is designed for use under the 32-bit Windows.

The minimal hardware requirements:

  • Pentium 100;

  • 16 Mb RAM;

  • 16 Mb on a hard disk.


User Interface

Comparing files or directories with Files Comparer is very simple: when the program starts, it presents Select Files dialog (fig. 1) where names of files or directories you wish to compare need to be specified (by typing, expanding the combo box, browsing to, or dropping one or two files/directories from Windows Explorer).

Fig. 1 Select Files and Directories dialog

A recursive option is supplied when comparing directories, which will recursively compare the contents of each subdirectory as well. You may specify which extensions you would like to compare using the Extensions field. To compare all files in the selected directories, enter *.* or leave the field blank.

If you want to specify multiple extensions, enter a semi-colon separated list of extensions such as the following:

*.cpp;*.hpp;*.c;*.h

When comparison process began you can see Progress window (fig. 2) with current results.

Fig. 2 Progress window


Options

Files Comparer supports a number of configuration options that you can set with the Options dialog (fig. 1). The options are divided into several pages that are indexed on the left side of the options dialog. Click on any entry to open that page.

Fig. 1 Options dialog

Each page deals with a separate topic and its associated options:

  • General - This page covers general comparison and view options.

  • Filters - Configures regular expression filters for ignoring lines.

  • Font and Colors - Configures how differences will be highlighted.


Comparing Files

Comparing Files and Directories

There are two different comparison views: text file view and directory view. After comparison is finished, its results are shown. Identical parts of compared files/directories synchronized, and modified parts identified as added, deleted, and changed, and clearly marked by different colors. Files Comparer automatically determines whether the files are text or binary.

Fig. 1 Directory Comparison Results window

If the comparison objects you have chosen are directories, Files Comparer displays the Directory Comparison Results window (fig. 1). This is a listing of each item that was encountered in both directories, and includes the name of the item, the relative location, and the results of the comparison.

Depending on the comparison result for a given file, you have a few options:

  • If the files are different, double-click the item to show the File Comparison View for that file.

  • If the file exists in only one of the specified directories, you can right click the list item and copy the file to the other side using the popup menu that appears.


Merging Files

Once you have started a comparison session, Files Comparer displays the selected files side-by-side in a splitter view, which is called the File Comparison view (fig. 1). Different colors are used to highlight the differences between the two files.

Fig. 1 File Comparison view

Modified parts of compared files are referred to as blocks. Files Comparer allows certain operations on blocks, such as deleting and copying from one item to another. Files Comparer always maintains one block (or difference) as current (unless compared items are identical), and block operations are performed on the current block.

The easiest way to step through the differences is to use the arrow keys with ALT on the keyboard. The down arrow key scrolls to the next difference in the file. The up arrow key scrolls to the previous difference. When you are comparing files with a large number of differences, you can also use the provided scrollbars to scroll to the general area and then hit the arrow key to find the difference.

Once you have selected a difference, you can synchronize one side with the other using the right and left arrow keys with ALT. Press the right arrow key to copy the selected area of the left file into the selected area of the right file. Likewise, press the left arrow key to copy the selected area of the right file into the selected area of the left file. Using just these few functions, you can easily navigate the differences between two files and merge changes as desired.

When you have finished comparing the current files, simply close the File Comparison window. If you have made any changes, you will be prompted to save them at this time. Note that you can also click the Save button before closing the window, if you wish.


Command Line Options

Usage: FilesComparer.exe [Name1] [Name2] [Options]

Name1, Name2 are names of files or directories to be compared.

Options are any of:

/r compare subdirectories recursively.


Using with file manager

Files Comparer has special feature that simplifies its usage from file manager if latter supports running external tools with parameters. You can pass either directories names or files name to compare.

For example, for Windows Commander you can define command as follows:

FilesComparer.exe %p%n %t%m

where %p - active panel path, %t - passive panel path, %n - current file name, %m - file name in inactive file name. If %n and %m are empty (files not selected) Files Comparer will process directories %p and %t.